VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SetWindowRgn Demo"
   ClientHeight    =   2655
   ClientLeft      =   1260
   ClientTop       =   1560
   ClientWidth     =   6135
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   177
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   409
   Begin VB.CommandButton Command1 
      Caption         =   "Push Me"
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   555
      Left            =   900
      TabIndex        =   0
      Top             =   720
      Width           =   1515
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   120
      Top             =   720
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 1995-2000 Karl E. Peterson, All Rights Reserved
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function FillRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function Polyline Lib "gdi32" (ByVal hDC As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type POINTAPI
   x As Long
   y As Long
End Type

Private scnPts() As POINTAPI
Private rgnPts() As POINTAPI

Private Const SM_CYCAPTION = 4
Private Const SM_CXFRAME = 32
Private Const SM_CYFRAME = 33

' PolyFill() Modes
Private Const ALTERNATE = 1
Private Const WINDING = 2

' Used to support captionless drag
Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTCAPTION = 2
' Undocumented message constant.
Private Const WM_GETSYSMENU = &H313
' Used to get window style bits.
Private Const GWL_STYLE = (-16)
' ControlBox style bit.
Private Const WS_THICKFRAME = &H40000
Private Const WS_SYSMENU = &H80000
Private Const WS_CAPTION = &HC00000
' Force non-client area to repaint.
Private Const WM_NCPAINT = &H85
' Force total redraw that shows new styles.
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOSIZE = &H1

' Constants used in demo
Private Const nPts As Long = 36

' Member variables
Private m_trns As CTranslucentForm
Private m_DemoRunning As Boolean

Private Sub Command1_Click()
   ' Flag variable tracks current state.
   m_DemoRunning = Not m_DemoRunning
   
   If m_DemoRunning Then
      ' Toggle titlebar off.
      Call ToggleCaption(False)
            
      ' Setup layered window class.
      Set m_trns = New CTranslucentForm
      m_trns.hWnd = Me.hWnd
      m_trns.Mode = lwaColorKey
      m_trns.ColorKey = vbGreen
      
      ' Set background to green so it
      ' becomes transparent.
      Me.BackColor = vbGreen
   
   Else
      ' Return background to normal
      Me.BackColor = vb3DFace
      ' Tear down layered window class
      Set m_trns = Nothing
      ' Toggle titlebar on.
      Call ToggleCaption(True)
   End If
   
   ' Enable timer appropriately.
   Timer1.Enabled = m_DemoRunning
   Command1.Visible = Not m_DemoRunning
End Sub

Private Sub Form_DblClick()
   ' Shift back if running.
   If m_DemoRunning Then Command1_Click
End Sub

Private Sub Form_Load()
   ' Setup form properties.
   With Me
      .ScaleMode = vbPixels
      .Width = Screen.Width \ 2
      .Height = .Width
      .Move (Screen.Width - .Width) \ 2, (Screen.Height - .Height) \ 2
      .Icon = Nothing
   End With
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   ' Allow captionless drag if demo
   ' is running in irregular mode.
   If Button = vbLeftButton Then
      If m_DemoRunning Then
         Call ReleaseCapture
         Call SendMessage(Me.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, ByVal 0&)
      End If
   End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   Dim pt As POINTAPI
   
   ' This is relative to the screen, so we can't
   ' use the coordinates passed in the event
   Call GetCursorPos(pt)
   If Button = vbRightButton Then
      If m_DemoRunning Then
         Call SendMessage(Me.hWnd, WM_GETSYSMENU, 0, ByVal MakeLong(pt.y, pt.x))
      End If
   End If
End Sub

Private Sub Form_Paint()
   Dim hBrush As Long
   Dim hRgn As Long
   
   ' Create region and a brush to fill it with.
   hBrush = CreateSolidBrush(vbRed)
   hRgn = CreatePolygonRgn(scnPts(0), nPts, ALTERNATE)
   Call FillRgn(Me.hDC, hRgn, hBrush)
   
   ' Clean up GDI objects.
   Call DeleteObject(hRgn)
   Call DeleteObject(hBrush)
   
   ' Draw outline around polygon.
   Call Polyline(Me.hDC, scnPts(0), nPts + 1)
End Sub

Private Sub Form_Resize()
   ' Adjust controls and painted region.
   With Me
      Command1.Move (.ScaleWidth - Command1.Width) \ 2, _
                    (.ScaleHeight - Command1.Height) \ 2
      If .Visible Then
         CalcRgnPoints
         .Refresh
      End If
   End With
End Sub

Private Static Sub Timer1_Timer()
   ' Rotate polygon.
   Call CalcRgnPoints
   Me.Refresh
End Sub

' *********************************************************************
'  Private methods
' *********************************************************************
Private Static Sub CalcRgnPoints()
   ReDim scnPts(0 To nPts) As POINTAPI
   ReDim rgnPts(0 To nPts) As POINTAPI
   Dim offset As Long
   Dim angle As Long
   Dim theta As Double
   Dim radius1 As Long
   Dim radius2 As Long
   Dim x1 As Long
   Dim y1 As Long
   Dim xOff As Long
   Dim yOff As Long
   Dim n As Long
   '
   ' Some useful constants.
   '
   Const Pi# = 3.14159265358979
   Const DegToRad# = Pi / 180
   '
   ' Calc radius based on form size.
   '
   x1 = Me.ScaleWidth \ 2
   y1 = Me.ScaleHeight \ 2
   If x1 > y1 Then
      radius1 = y1 * 0.85
   Else
      radius1 = x1 * 0.85
   End If
   radius2 = radius1 * 0.5
   '
   ' Offsets to move origin to upper
   ' left of window.
   '
   xOff = GetSystemMetrics(SM_CXFRAME)
   yOff = GetSystemMetrics(SM_CYFRAME) + GetSystemMetrics(SM_CYCAPTION)
   '
   ' Step through a circle, 10 degrees each
   ' loop, finding points for polygon.
   '
   n = 0
   For angle = 0 To 360 Step 10
      theta = (angle - offset) * DegToRad
      '
      ' First region is for drawing.
      ' One long, one short, one long...
      '
      If n Mod 2 Then
         scnPts(n).x = x1 + (radius1 * (Sin(theta)))
         scnPts(n).y = y1 + (radius1 * (Cos(theta)))
      Else
         scnPts(n).x = x1 + (radius2 * (Sin(theta)))
         scnPts(n).y = y1 + (radius2 * (Cos(theta)))
      End If
      '
      ' Second region is for clipping.
      ' Add offsets.
      '
      rgnPts(n).x = scnPts(n).x + xOff
      rgnPts(n).y = scnPts(n).y + yOff
      n = n + 1
   Next angle

   offset = (offset + 2) Mod 360
End Sub

Private Function MakeLong(ByVal WordHi As Variant, ByVal WordLo As Integer) As Long
   ' High word is coerced to a variant on call to allow
   ' it to overflow limits of multiplication which shifts
   ' it left.
   MakeLong = (WordHi * &H10000) + (WordLo And &HFFFF&)
End Function

Private Function ToggleCaption(ByVal Value As Boolean) As Boolean
   Dim nStyle As Long
   
   ' Retrieve current style bits.
   nStyle = GetWindowLong(Me.hWnd, GWL_STYLE)
   ' Set WS_SYSMENU On or Off as requested.
   If Value Then
      nStyle = nStyle Or WS_CAPTION Or WS_THICKFRAME
   Else
      nStyle = nStyle And Not WS_CAPTION
      nStyle = nStyle And Not WS_THICKFRAME
   End If
   
   ' Try to set new style.
   If SetWindowLong(Me.hWnd, GWL_STYLE, nStyle) Then
      If nStyle = GetWindowLong(Me.hWnd, GWL_STYLE) Then
         ToggleCaption = True
      End If
   End If
   
   ' Redraw window with new style.
   SetWindowPos hWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOZORDER Or SWP_NOSIZE
End Function
